Abstract out qemu-nbd/NBD/loopback mount of disk image.
[tridge/autocluster.git] / autocluster
1 #!/bin/bash
2 # main autocluster script
3 #
4 # Copyright (C) Andrew Tridgell  2008
5 # Copyright (C) Martin Schwenke  2008
6 #
7 # This program is free software; you can redistribute it and/or modify
8 # it under the terms of the GNU General Public License as published by
9 # the Free Software Foundation; either version 3 of the License, or
10 # (at your option) any later version.
11 #   
12 # This program is distributed in the hope that it will be useful,
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
15 # GNU General Public License for more details.
16 #   
17 # You should have received a copy of the GNU General Public License
18 # along with this program; if not, see <http://www.gnu.org/licenses/>.
19
20 ##BEGIN-INSTALLDIR-MAGIC##
21 # There are better ways of doing this but not if you still want to be
22 # able to run straight out of a git tree.  :-)
23 if [ -f "$0" ]; then
24     installdir="`dirname \"$0\"`"
25 else
26     autocluster=`which $0`
27     installdir="`dirname \"$autocluster\"`"
28 fi
29 ##END-INSTALLDIR-MAGIC##
30
31 ####################
32 # show program usage
33 usage ()
34 {
35     cat <<EOF
36 Usage: autocluster [OPTION] ... <COMMAND>
37   options:
38      -c <file>                   specify config file (default is "config")
39 EOF
40
41     releases=$(list_releases)
42
43     usage_smart_display \
44         defconf "WITH_RELEASE" "" \
45         "<string>" "specify preset options for a release using a version string.  Possible values are: ${releases}."
46
47 cat <<EOF
48      -e <expr>                   execute <expr> and exit
49      -E <expr>                   execute <expr> and continue
50      -x                          enable script debugging
51      --dump                      dump config settings and exit
52
53   configuration options:
54 EOF
55
56     usage_config_options
57
58     cat <<EOF
59
60   commands:
61      create base
62            create a base image
63
64      create cluster CLUSTERNAME
65            create a full cluster
66
67      create node CLUSTERNAME IP_OFFSET
68            (re)create a single cluster node
69
70      mount DISK
71            mount a qemu disk on mnt/
72
73      unmount
74            unmount a qemu disk from mnt/
75
76      bootbase
77            boot the base image
78
79      testproxy
80            test your proxy setup
81 EOF
82     exit 1
83 }
84
85 ###############################
86
87 die () {
88     fill_text 0 "ERROR: $*" >&2
89     exit 1
90 }
91
92 ###############################
93
94 # Indirectly call a function named by ${1}_${2}
95 call_func () {
96     local __func="$1" ; shift
97     local __type="$1" ; shift
98
99     local f="${__func}_${__type}"
100     if type -t "$f" >/dev/null && ! type -P "$f" >/dev/null ; then
101         "$f" "$@"
102     else
103         f="${__func}_DEFAULT"
104         if type -t "$f" >/dev/null && ! type -P "$f" >/dev/null  ; then
105             "$f" "$__type" "$@"
106         else
107             die "No function defined for \"${__func}\" \"${__type}\""
108         fi
109     fi
110 }
111
112 # Note that this will work if you pass "call_func f" because the first
113 # element of the node tuple is the node type.  Nice...  :-)
114 for_each_node ()
115 {
116     local n
117     for n in $NODES ; do
118         "$@" $(IFS=: ; echo $n)
119     done
120 }
121
122 hack_one_node_with ()
123 {
124     local filter="$1" ; shift
125
126     local node_type="$1"
127     local ip_offset="$2"
128     local name="$3"
129     local ctdb_node="$4"
130
131     $filter
132
133     local item="${node_type}:${ip_offset}${name:+:}${name}${ctdb_node:+:}${ctdb_node}"
134     nodes="${nodes}${nodes:+ }${item}"
135 }
136
137 # This also gets used for non-filtering iteration.
138 hack_all_nodes_with ()
139 {
140     local filter="$1"
141
142     local nodes=""
143     for_each_node hack_one_node_with "$filter"
144     NODES="$nodes"
145 }
146
147 register_hook ()
148 {
149     local hook_var="$1"
150     local new_hook="$2"
151
152     eval "$hook_var=\"${!hook_var}${!hook_var:+ }${new_hook}\""
153 }
154
155 run_hooks ()
156 {
157     local hook_var="$1"
158
159     local i
160     for i in ${!hook_var} ; do
161         $i
162     done
163 }
164
165 # Use with care, since this may clear some autocluster defaults.!
166 clear_hooks ()
167 {
168     local hook_var="$1"
169
170     eval "$hook_var=\"\""
171 }
172
173 ##############################
174
175 # common node creation stuff
176 create_node_COMMON ()
177 {
178     local NAME="$1"
179     local ip_offset="$2"
180     local type="$3"
181     local template_file="${4:-$NODE_TEMPLATE}"
182
183     if [ "$SYSTEM_DISK_FORMAT" != "qcow2" -a "$BASE_FORMAT" = "qcow2" ] ; then
184         die "Error: if BASE_FORMAT is \"qcow2\" then SYSTEM_DISK_FORMAT must also be \"qcow2\"."
185     fi
186
187     IPNUM=$(($FIRSTIP + $ip_offset))
188     DISK="${VIRTBASE}/${CLUSTER}/${NAME}.${SYSTEM_DISK_FORMAT}"
189     local base_disk="${VIRTBASE}/${BASENAME}.${BASE_FORMAT}"
190
191     if [ "$BASE_PER_NODE_TYPE" = "yes" ] ; then
192         base_disk="${VIRTBASE}/${BASENAME}-${type}.${BASE_FORMAT}"
193     fi
194
195     mkdir -p $VIRTBASE/$CLUSTER tmp
196
197     rm -f "$DISK"
198     case "$SYSTEM_DISK_FORMAT" in
199         qcow2)
200             echo "Creating the disk..."
201             qemu-img create -b "$base_disk" -f qcow2 "$DISK"
202             create_node_configure_image "$DISK" "$type"
203             ;;
204         raw)
205             echo "Creating the disk..."
206             cp -v --sparse=always "$base_disk" "$DISK"
207             create_node_configure_image "$DISK" "$type"
208             ;;
209         reflink)
210             echo "Creating the disk..."
211             cp -v --reflink=always "$base_disk" "$DISK"
212             create_node_configure_image "$DISK" "$type"
213             ;;
214         none)
215             echo "Skipping disk image creation as requested"
216             ;;
217         *)
218             die "Error: unknown SYSTEM_DISK_FORMAT=\"${SYSTEM_DISK_FORMAT}\"."
219     esac
220
221     set_macaddrs $CLUSTER $ip_offset
222
223     # Pull the UUID for this node out of the map.
224     UUID=$(awk "\$1 == $ip_offset {print \$2}" $uuid_map)
225     
226     echo "Creating $NAME.xml"
227     substitute_vars $template_file tmp/$NAME.xml
228     
229     # install the XML file
230     $VIRSH undefine $NAME > /dev/null 2>&1 || true
231     $VIRSH define tmp/$NAME.xml
232 }
233
234 create_node_configure_image ()
235 {
236     local disk="$1"
237     local type="$2"
238
239     diskimage_mount "$disk"
240     setup_base "$type"
241     diskimage_unmount
242 }
243
244 # Provides an easy way of removing nodes from $NODE.
245 create_node_null () {
246     :
247 }
248
249 ##############################
250
251 hack_nodes_functions=
252
253 expand_nodes () {
254     # Expand out any abbreviations in NODES.
255     local ns=""
256     local n
257     for n in $NODES ; do
258         local t="${n%:*}"
259         local ips="${n#*:}"
260         case "$ips" in
261             *,*)
262                 local i
263                 for i in ${ips//,/ } ; do
264                     ns="${ns}${ns:+ }${t}:${i}"
265                 done
266                 ;;
267             *-*)
268                 local i
269                 for i in $(seq ${ips/-/ }) ; do
270                     ns="${ns}${ns:+ }${t}:${i}"
271                 done
272                 ;;
273             *)
274                 ns="${ns}${ns:+ }${n}"
275         esac
276     done
277     NODES="$ns"
278
279     # Apply nodes hacks.  Some of this is about backward compatibility
280     # but the hacks also fill in the node names and whether they're
281     # part of the CTDB cluster.  The order is the order that
282     # configuration modules register their hacks.
283     run_hooks hack_nodes_functions
284
285     if [ -n "$NUMNODES" ] ; then
286         # Attempt to respect NUMNODES.  Reduce the number of CTDB
287         # nodes to NUMNODES.
288         local numnodes=$NUMNODES
289
290         hack_filter ()
291         {
292             if [ "$ctdb_node" = 1 ] ; then
293                 if [ $numnodes -gt 0 ] ; then
294                     numnodes=$(($numnodes - 1))
295                 else
296                     node_type="null"
297                     ctdb_node=0
298                 fi
299             fi
300         }
301
302         hack_all_nodes_with hack_filter
303                         
304         [ $numnodes -gt 0 ] && \
305             die "Can't not use NUMNODES to increase the number of nodes over that specified by NODES.  You need to set NODES instead - please read the documentation."
306     fi
307     
308     # Check IP addresses for duplicates.
309     local ip_offsets=":"
310     # This function doesn't modify anything...
311     get_ip_offset ()
312     {
313         [ "${ip_offsets/${ip_offset}}" != "$ip_offsets" ] && \
314             die "Duplicate IP offset in NODES - ${node_type}:${ip_offset}"
315         ip_offsets="${ip_offsets}${ip_offset}:"
316     }
317     hack_all_nodes_with get_ip_offset
318 }
319
320 ##############################
321
322 sanity_check_cluster_name ()
323 {
324     [ -z "${CLUSTER//[A-Za-z0-9]}" ] || \
325         die "Cluster names should be restricted to the characters A-Za-z0-9.  \
326 Some cluster filesystems have problems with other characters."
327 }
328
329 hosts_file=
330
331 common_nodelist_hacking ()
332 {
333     # Rework the NODES list
334     expand_nodes
335
336     # Build /etc/hosts and hack the names of the ctdb nodes
337     hosts_line_hack_name ()
338     {
339         # Ignore nodes without names (e.g. "null")
340         [ "$node_type" != "null" -a -n "$name" ] || return 0
341
342         local sname=""
343         local hosts_line
344         local ip_addr="$IPBASE.$IPNET0.$(($FIRSTIP + $ip_offset))"
345         
346         if [ "$ctdb_node" = 1 ] ; then
347             num_ctdb_nodes=$(($num_ctdb_nodes + 1))
348             sname="${CLUSTER}n${num_ctdb_nodes}"
349             hosts_line="$ip_addr ${sname}.${ld} ${name}.${ld} $name $sname"
350             name="$sname"
351         else
352             hosts_line="$ip_addr ${name}.${ld} $name"
353         fi
354
355         # This allows you to add a function to your configuration file
356         # to modify hostnames (and other aspects of nodes).  This
357         # function can access/modify $name (the existing name),
358         # $node_type and $ctdb_node (1, if the node is a member of the
359         # CTDB cluster, 0 otherwise).
360         if [ -n "$HOSTNAME_HACKING_FUNCTION" ] ; then
361             local old_name="$name"
362             $HOSTNAME_HACKING_FUNCTION
363             if [ "$name" != "$old_name" ] ; then
364                 hosts_line="$ip_addr ${name}.${ld} $name"
365             fi
366         fi
367
368         echo "$hosts_line"
369     }
370     hosts_file="tmp/hosts.$CLUSTER"
371     {
372         local num_ctdb_nodes=0
373         local ld=$(echo $DOMAIN | tr A-Z a-z)
374         echo "# autocluster $CLUSTER"
375         hack_all_nodes_with hosts_line_hack_name
376         echo
377     } >$hosts_file
378
379     # Build /etc/ctdb/nodes
380     ctdb_nodes_line ()
381     {
382         [ "$ctdb_node" = 1 ] || return 0
383         echo "$IPBASE.$IPNET0.$(($FIRSTIP + $ip_offset))"
384         num_nodes=$(($num_nodes + 1))
385     }
386     nodes_file="tmp/nodes.$CLUSTER"
387     local num_nodes=0
388     hack_all_nodes_with ctdb_nodes_line >$nodes_file
389     : "${NUMNODES:=${num_nodes}}"  # Set $NUMNODES if necessary
390
391     # Build UUID map
392     uuid_map="tmp/uuid_map.$CLUSTER"
393     uuid_map_line ()
394     {
395         echo "${ip_offset} $(uuidgen) ${node_type}"
396     }
397     hack_all_nodes_with uuid_map_line >$uuid_map
398 }
399
400 create_cluster_hooks=
401 cluster_created_hooks=
402
403 create_cluster ()
404 {
405     CLUSTER="$1"
406
407     sanity_check_cluster_name
408
409     mkdir -p $VIRTBASE/$CLUSTER $KVMLOG tmp
410
411     # Run hooks before doing anything else.
412     run_hooks create_cluster_hooks
413
414     common_nodelist_hacking
415
416     for_each_node call_func create_node
417
418     echo "Cluster $CLUSTER created"
419     echo ""
420
421     run_hooks cluster_created_hooks
422 }
423
424 cluster_created_hosts_message ()
425 {
426     echo "You may want to add this to your /etc/hosts file:"
427     cat $hosts_file
428 }
429
430 register_hook cluster_created_hooks cluster_created_hosts_message
431
432 create_one_node ()
433 {
434     CLUSTER="$1"
435     local single_node_ip_offset="$2"
436
437     sanity_check_cluster_name
438
439     mkdir -p $VIRTBASE/$CLUSTER $KVMLOG tmp
440
441     common_nodelist_hacking
442
443     for n in $NODES ; do
444         set -- $(IFS=: ; echo $n)
445         [ $single_node_ip_offset -eq $2 ] || continue
446         call_func create_node "$@"
447         
448         echo "Requested node created"
449         echo ""
450         echo "You may want to update your /etc/hosts file:"
451         cat $hosts_file
452         
453         break
454     done
455 }
456
457 ###############################
458 # test the proxy setup
459 test_proxy() {
460     export http_proxy=$WEBPROXY
461     wget -O /dev/null $INSTALL_SERVER || \
462         die "Your WEBPROXY setting \"$WEBPROXY\" is not working"
463     echo "Proxy OK"
464 }
465
466 ###################
467
468 kickstart_floppy_create_hooks=
469
470 # create base image
471 create_base() {
472
473     NAME="$BASENAME"
474     DISK="${VIRTBASE}/${NAME}.${BASE_FORMAT}"
475
476     mkdir -p $KVMLOG
477
478     echo "Testing WEBPROXY $WEBPROXY"
479     test_proxy
480
481     echo "Creating the disk"
482     qemu-img create -f $BASE_FORMAT "$DISK" $DISKSIZE
483
484     rm -rf tmp
485     mkdir -p mnt tmp tmp/ISO
486
487     setup_timezone
488
489     echo "Creating kickstart file from template"
490     substitute_vars "$KICKSTART" "tmp/ks.cfg"
491
492     if [ $INSTALLKEY = "--skip" ]; then
493         cat <<EOF
494 --------------------------------------------------------------------------------------
495 WARNING: You have not entered an install key. Some RHEL packages will not be installed.
496
497 Please enter a valid RHEL install key in your config file like this:
498
499   INSTALLKEY="1234-5678-0123-4567"
500
501 The install will continue without an install key in 5 seconds
502 --------------------------------------------------------------------------------------
503 EOF
504         sleep 5
505     fi
506
507     # $ISO gets $ISO_DIR prepended if it doesn't start with a leading '/'.
508     case "$ISO" in
509         (/*) : ;;
510         (*) ISO="${ISO_DIR}/${ISO}"
511     esac
512     
513     echo "Creating kickstart floppy"
514     dd if=/dev/zero of=tmp/floppy.img bs=1024 count=1440
515     mkdosfs tmp/floppy.img
516     mount -o loop -t msdos tmp/floppy.img mnt
517     cp tmp/ks.cfg mnt
518     mount -o loop,ro $ISO tmp/ISO
519     
520     echo "Setting up bootloader"
521     cp tmp/ISO/isolinux/isolinux.bin tmp
522     cp tmp/ISO/isolinux/vmlinuz tmp
523     cp tmp/ISO/isolinux/initrd.img tmp
524
525     run_hooks kickstart_floppy_create_hooks
526
527     umount tmp/ISO
528     umount mnt
529
530     UUID=`uuidgen`
531
532     substitute_vars $INSTALL_TEMPLATE tmp/$NAME.xml
533
534     rm -f $KVMLOG/serial.$NAME
535
536     # boot the install CD
537     $VIRSH create tmp/$NAME.xml
538
539     echo "Waiting for install to start"
540     sleep 2
541     
542     # wait for the install to finish
543     if ! waitfor $KVMLOG/serial.$NAME "$KS_DONE_MESSAGE" $CREATE_BASE_TIMEOUT ; then
544         $VIRSH destroy $NAME
545         die "Failed to create base image $DISK"
546     fi
547     
548     $VIRSH destroy $NAME
549
550     ls -l $DISK
551     cat <<EOF
552
553 Install finished, base image $DISK created
554
555 You may wish to run
556    chattr +i $DISK
557 To ensure that this image does not change
558
559 Note that the root password has been set to $ROOTPASSWORD
560
561 EOF
562 }
563
564 ###############################
565 # boot the base disk
566 boot_base() {
567     CLUSTER="$1"
568
569     NAME="$BASENAME"
570     DISK="${VIRTBASE}/${NAME}.${BASE_FORMAT}"
571
572     rm -rf tmp
573     mkdir -p tmp
574
575     IPNUM=$FIRSTIP
576     CLUSTER="base"
577
578     diskimage_mount $DISK
579     setup_base
580     diskimage_unmount
581
582     UUID=`uuidgen`
583     
584     echo "Creating $NAME.xml"
585     substitute_vars $BOOT_TEMPLATE tmp/$NAME.xml
586     
587     # boot the base system
588     $VIRSH create tmp/$NAME.xml
589 }
590
591 ######################################################################
592
593 # various functions...
594
595 # Set some MAC address variables based on a hash of the cluster name
596 # plus the node number and each adapter number.
597 set_macaddrs () {
598     local cname="$1"
599     local ip_offset="$2"
600
601     local md5=$(echo $cname | md5sum)
602     local nh=$(printf "%02x" $ip_offset)
603     local mac_prefix="02:${md5:0:2}:${md5:2:2}:00:${nh}:"
604
605     MAC1="${mac_prefix}01"
606     MAC2="${mac_prefix}02"
607     MAC3="${mac_prefix}03"
608     MAC4="${mac_prefix}04"
609     MAC5="${mac_prefix}05"
610     MAC6="${mac_prefix}06"
611 }
612
613 ######################################################################
614
615 # Updating a disk image...
616
617 make_system_disk_access_function ()
618 {
619     eval "$1 () { call_func $1 \"\$SYSTEM_DISK_ACCESS_METHOD\" \"\$@\" ; }"
620 }
621
622 for i in \
623     mount unmount \
624     mkdir_p substitute_vars chmod chmod_reference \
625     is_directory append_text_file append_text sed put ln_s command \
626     ; do
627     make_system_disk_access_function "diskimage_$i"
628 done
629
630 # setup the files from $BASE_TEMPLATES/, substituting any variables
631 # based on the config
632 copy_base_dir_substitute_templates ()
633 {
634     local dir="$1"
635
636     local d="$BASE_TEMPLATES/$dir"
637     [ -d "$d" ] || return 0
638
639     local f
640     for f in $(cd "$d" && find . \! -name '*~') ; do
641         f="${f#./}" # remove leading "./" for clarity
642         if [ -d "$d/$f" ]; then
643             diskimage_mkdir_p "/$f"
644         else 
645             diskimage_substitute_vars "$d/$f" "/$f"
646         fi
647         diskimage_chmod_reference "$d/$f" "/$f"
648     done
649 }
650
651 setup_base_hooks=
652
653 setup_base_ssh_keys ()
654 {
655     # this is needed as git doesn't store file permissions other
656     # than execute
657     # Note that we protect the wildcards from the local shell.
658     diskimage_chmod 600 "/etc/ssh/*key" "/root/.ssh/*"
659     diskimage_chmod 700 "/etc/ssh" "/root/.ssh" "/root"
660     if [ -r "$HOME/.ssh/id_rsa.pub" ]; then
661        echo "Adding $HOME/.ssh/id_rsa.pub to ssh authorized_keys"
662        diskimage_append_text_file "$HOME/.ssh/id_rsa.pub" "/root/.ssh/authorized_keys"
663     fi
664     if [ -r "$HOME/.ssh/id_dsa.pub" ]; then
665        echo "Adding $HOME/.ssh/id_dsa.pub to ssh authorized_keys"
666        diskimage_append_text_file "$HOME/.ssh/id_dsa.pub" "/root/.ssh/authorized_keys"
667     fi
668 }
669
670 register_hook setup_base_hooks setup_base_ssh_keys
671
672 setup_base_grub_conf ()
673 {
674     echo "Adjusting grub.conf"
675     local o="$EXTRA_KERNEL_OPTIONS" # For readability.
676     diskimage_sed "/boot/grub/grub.conf" \
677         -e "s/console=ttyS0,19200/console=ttyS0,115200/"  \
678         -e "s/ nodmraid//" -e "s/ nompath//"  \
679         -e "s/quiet/noapic divider=10${o:+ }${o}/g"
680 }
681
682 register_hook setup_base_hooks setup_base_grub_conf
683
684 setup_base()
685 {
686     local type="$1"
687
688     umask 022
689     echo "Copy base files"
690     copy_base_dir_substitute_templates "all"
691     if [ -n "$type" ] ; then
692         copy_base_dir_substitute_templates "$type"
693     fi
694
695     run_hooks setup_base_hooks
696 }
697
698 # setup various networking components
699 setup_network()
700 {
701     # This avoids doing anything when we're called from boot_base().
702     if [ -z "$hosts_file" ] ; then
703         echo "Skipping network-related setup"
704         return
705     fi
706
707     echo "Setting up networks"
708     diskimage_append_text_file "$hosts_file" "/etc/hosts"
709
710     echo "Setting up /etc/ctdb/nodes"
711     diskimage_mkdir_p "/etc/ctdb"
712     diskimage_put "$nodes_file" "/etc/ctdb/nodes"
713
714     [ "$WEBPROXY" = "" ] || {
715         diskimage_append_text "export http_proxy=$WEBPROXY" "/etc/bashrc"
716     }
717
718     if [ -n "$NFSSHARE" -a -n "$NFS_MOUNTPOINT" ] ; then
719         echo "Enabling nfs mount of $NFSSHARE"
720         diskimage_mkdir_p "$NFS_MOUNTPOINT"
721         diskimage_append_text "$NFSSHARE $NFS_MOUNTPOINT nfs intr" "/etc/fstab"
722     fi
723
724     diskimage_mkdir_p "/etc/yum.repos.d"
725     echo '@@@YUM_TEMPLATE@@@' | diskimage_substitute_vars - "/etc/yum.repos.d/autocluster.repo"
726 }
727
728 register_hook setup_base_hooks setup_network
729
730 setup_timezone() {
731     [ -z "$TIMEZONE" ] && {
732         [ -r /etc/timezone ] && {
733             TIMEZONE=`cat /etc/timezone`
734         }
735         [ -r /etc/sysconfig/clock ] && {
736             . /etc/sysconfig/clock
737             TIMEZONE="$ZONE"
738         }
739         TIMEZONE="${TIMEZONE// /_}"
740     }
741     [ -n "$TIMEZONE" ] || \
742         die "Unable to determine TIMEZONE - please set in config"
743 }
744
745 # substite a set of variables of the form @@XX@@ for the shell
746 # variables $XX in a file.
747 #
748 # Indirect variables @@@XX@@@ (3 ats) specify that the variable should
749 # contain a filename whose contents are substituted, with variable
750 # substitution applied to those contents.  If filename starts with '|'
751 # it is a command instead - however, quoting is extremely fragile.
752 substitute_vars() {(
753         infile="${1:-/dev/null}" # if empty then default to /dev/null
754         outfile="$2" # optional
755
756         instring=$(cat $infile)
757
758         # Handle any indirects by looping until nothing changes.
759         # However, only handle 10 levels of recursion.
760         count=0
761         while : ; do
762             outstring=$(_substitute_vars "$instring" "@@@")
763             [ $? -eq 0 ] || die "Failed to expand template $infile"
764
765             [ "$instring" = "$outstring" ] && break
766
767             count=$(($count + 1))
768             [ $count -lt 10 ] || \
769                 die "Recursion too deep in $infile - only 10 levels allowed!"
770
771             instring="$outstring"
772         done
773
774         # Now regular variables.
775         outstring=$(_substitute_vars "$instring" "@@")
776         [ $? -eq 0 ] || die "Failed to expand template $infile"
777
778         if [ -n "$outfile" ] ; then
779             echo "$outstring" > "$outfile"
780         else
781             echo "$outstring"
782         fi
783 )}
784
785
786 # Delimiter @@ means to substitute contents of variable.
787 # Delimiter @@@ means to substitute contents of file named by variable.
788 # @@@ supports leading '|' in variable value, which means to excute a
789 # command.
790 _substitute_vars() {(
791         instring="$1"
792         delimiter="${2:-@@}"
793
794         # Get the list of variables used in the template.  The grep
795         # gets rid of any blank lines and lines with extraneous '@'s
796         # next to template substitutions.
797         VARS=$(echo "$instring" |
798             sed -n -e "s#[^@]*${delimiter}\([A-Z0-9_][A-Z0-9_]*\)${delimiter}[^@]*#\1\n#gp" |
799             grep '^[A-Z0-9_][A-Z0-9_]*$' |
800             sort -u)
801
802         tmp=$(mktemp)
803         for v in $VARS; do
804             # variable variables are fun .....
805             [ "${!v+x}" ] || {
806                 rm -f $tmp
807                 die "No substitution given for ${delimiter}$v${delimiter} in $infile"
808             }
809             s=${!v}
810
811             if [ "$delimiter" = "@@@" ] ; then
812                 f=${s:-/dev/null}
813                 c="${f#|}" # Is is a command, signified by a leading '|'?
814                 if [ "$c" = "$f" ] ; then
815                     # No leading '|', cat file.
816                     s=$(cat -- "$f")
817                     [ $? -eq 0 ] || {
818                         rm -f $tmp
819                         die "Could not substitute contents of file $f"
820                     }
821                 else
822                     # Leading '|', execute command.
823                     # Quoting problems here - using eval "$c" doesn't help.
824                     s=$($c)
825                     [ $? -eq 0 ] || {
826                         rm -f $tmp
827                         die "Could not execute command $c"
828                     }
829                 fi
830             fi
831
832             # escape some pesky chars
833             # This first one can be too slow if done using a bash
834             # variable pattern subsitution.
835             s=$(echo -n "$s" | tr '\n' '\001' | sed -e 's/\o001/\\n/g')
836             s=${s//#/\\#}
837             s=${s//&/\\&}
838             echo "s#${delimiter}${v}${delimiter}#${s}#g"
839         done > $tmp
840
841         echo "$instring" | sed -f $tmp
842
843         rm -f $tmp
844 )}
845
846 check_command() {
847     which $1 > /dev/null || die "Please install $1 to continue"
848 }
849
850 # Set a variable if it isn't already set.  This allows environment
851 # variables to override default config settings.
852 defconf() {
853     local v="$1"
854     local e="$2"
855
856     [ "${!v+x}" ] || eval "$v=\"$e\""
857 }
858
859 load_config () {
860     local i
861
862     for i in "${installdir}/config.d/"*.defconf ; do
863         . "$i"
864     done
865 }
866
867 # Print the list of config variables defined in config.d/.
868 get_config_options () {( # sub-shell for local declaration of defconf()
869         local options=
870         defconf() { options="$options $1" ; }
871         load_config
872         echo $options
873 )}
874
875 # Produce a list of long options, suitable for use with getopt, that
876 # represent the config variables defined in config.d/.
877 getopt_config_options () {
878     local x=$(get_config_options | tr 'A-Z_' 'a-z-')
879     echo "${x// /:,}:"
880 }
881
882 # Unconditionally set the config variable associated with the given
883 # long option.
884 setconf_longopt () {
885     local longopt="$1"
886     local e="$2"
887
888     local v=$(echo "${longopt#--}" | tr 'a-z-' 'A-Z_')
889     # unset so defconf will set it
890     eval "unset $v"
891     defconf "$v" "$e"
892 }
893
894 # Dump all of the current config variables.
895 dump_config() {
896     local o
897     for o in $(get_config_options) ; do
898         echo "${o}=\"${!o}\""
899     done
900     exit 0
901 }
902
903 # $COLUMNS is set in interactive bash shells.  It probably isn't set
904 # in this shell, so let's set it if it isn't.
905 : ${COLUMNS:=$(stty size 2>/dev/null | sed -e 's@.* @@')}
906 : ${COLUMNS:=80}
907 export COLUMNS
908
909 # Print text assuming it starts after other text in $startcol and
910 # needs to wrap before $COLUMNS - 2.  Subsequent lines start at $startcol.
911 # Long "words" will extend past $COLUMNS - 2.
912 fill_text() {
913     local startcol="$1"
914     local text="$2"
915
916     local width=$(($COLUMNS - 2 - $startcol))
917     [ $width -lt 0 ] && width=$((78 - $startcol))
918
919     local out=""
920
921     local padding
922     if [ $startcol -gt 0 ] ; then
923         padding=$(printf "\n%${startcol}s" " ")
924     else
925         padding="
926 "
927     fi
928
929     while [ -n "$text" ] ; do
930         local orig="$text"
931
932         # If we already have output then arrange padding on the next line.
933         [ -n "$out" ] && out="${out}${padding}"
934
935         # Break the text at $width.
936         out="${out}${text:0:${width}}"
937         text="${text:${width}}"
938
939         # If we have left over text then the line break may be ugly,
940         # so let's check and try to break it on a space.
941         if [ -n "$text" ] ; then
942             # The 'x's stop us producing a special character like '(',
943             # ')' or '!'.  Yuck - there must be a better way.
944             if [ "x${text:0:1}" != "x " -a "x${text: -1:1}" != "x " ] ; then
945                 # We didn't break on a space.  Arrange for the
946                 # beginning of the broken "word" to appear on the next
947                 # line but not if it will make us loop infinitely.
948                 if [ "${orig}" != "${out##* }${text}" ] ; then
949                     text="${out##* }${text}"
950                     out="${out% *}"
951                 else
952                     # Hmmm, doing that would make us loop, so add the
953                     # rest of the word from the remainder of the text
954                     # to this line and let it extend past $COLUMNS - 2.
955                     out="${out}${text%% *}"
956                     if [ "${text# *}" != "$text" ] ; then
957                         # Remember the text after the next space for next time.
958                         text="${text# *}"
959                     else
960                         # No text after next space.
961                         text=""
962                     fi
963                 fi
964             else
965                 # We broke on a space.  If it will be at the beginning
966                 # of the next line then remove it.
967                 text="${text# }"
968             fi
969         fi
970     done
971
972     echo "$out"
973 }
974
975 # Display usage text, trying these approaches in order.
976 # 1. See if it all fits on one line before $COLUMNS - 2.
977 # 2. See if splitting before the default value and indenting it
978 #    to $startcol means that nothing passes $COLUMNS - 2.
979 # 3. Treat the message and default value as a string and just us fill_text()
980 #    to format it. 
981 usage_display_text () {
982     local startcol="$1"
983     local desc="$2"
984     local default="$3"
985     
986     local width=$(($COLUMNS - 2 - $startcol))
987     [ $width -lt 0 ] && width=$((78 - $startcol))
988
989     default="(default \"$default\")"
990
991     if [ $((${#desc} + 1 + ${#default})) -le $width ] ; then
992         echo "${desc} ${default}"
993     else
994         local padding=$(printf "%${startcol}s" " ")
995
996         if [ ${#desc} -lt $width -a ${#default} -lt $width ] ; then
997             echo "$desc"
998             echo "${padding}${default}"
999         else
1000             fill_text $startcol "${desc} ${default}"
1001         fi
1002     fi
1003 }
1004
1005 # Display usage information for long config options.
1006 usage_smart_display () {( # sub-shell for local declaration of defconf()
1007         local startcol=33
1008
1009         defconf() {
1010             local local longopt=$(echo "$1" | tr 'A-Z_' 'a-z-')
1011
1012             printf "     --%-25s " "${longopt}=${3}"
1013
1014             usage_display_text $startcol "$4" "$2"
1015         }
1016
1017         "$@"
1018 )}
1019
1020
1021 # Display usage information for long config options.
1022 usage_config_options (){
1023     usage_smart_display load_config
1024 }
1025
1026 list_releases () {
1027     local releases=$(cd $installdir/releases && echo *.release)
1028     releases="${releases//.release}"
1029     releases="${releases// /\", \"}"
1030     echo "\"$releases\""
1031 }
1032
1033 with_release () {
1034     local release="$1"
1035     shift # subsequent args are passed to release file
1036
1037     # This simply loads an extra config file from $installdir/releases
1038     f="${installdir}/releases/${release}.release"
1039     if [ -r "$f" ] ; then
1040         . "$f"
1041     else
1042         f="${installdir}/releases/${release%%-*}.release"
1043         if [ -r "$f" ] ; then
1044             . "$f" "${release#*-}"
1045         else
1046             echo "Unknown release \"${release}\" specified to --with-release"
1047             printf "%-25s" "Supported releases are: "
1048             fill_text 25 "$(list_releases)"
1049             exit 1
1050         fi
1051     fi
1052
1053 }
1054
1055 has_public_addresses_DEFAULT ()
1056 {
1057     false
1058 }
1059
1060 # Build public address configuration.
1061 # * 1st public IP:  unless specified, last octet is $FIRSTIP + $PUBLIC_IP_OFFSET
1062 # * Excluded nodes: unless specified via comma-separated list of IP offsets,
1063 #                   nodes are excluded via their node types
1064 # * Number of public addresses per interface is either specified or $NUMNODES.
1065 make_public_addresses () {
1066     local firstip="${1:-$(($FIRSTIP + $PUBLIC_IP_OFFSET))}"
1067     local excluded_nodes="$2" 
1068     local num_addrs="${3:-${NUMNODES}}"
1069
1070     # For delimiting matches.
1071     excluded_nodes="${excluded_nodes:+,}${excluded_nodes}${excluded_nodes:+,}"
1072     # Avoid spaces
1073     excluded_nodes="${excluded_nodes// /}"
1074
1075     make_public_addresses_for_node ()
1076     {
1077         [ "$ctdb_node" = 1 ] || return 0
1078
1079         echo "[/etc/ctdb/public_addresses:${name}.${DOMAIN}]"
1080
1081         if [ -n "$excluded_nodes" -a \
1082             "${excluded_nodes/,${ip_offset},}" = "$excluded_nodes" ] ||
1083             ([ -z "$excluded_nodes" ] &&
1084                 call_func has_public_addresses "$node_type") ; then
1085
1086             local e i
1087             for e in $IPNET1 $IPNET2 ; do
1088                 for i in $(seq $firstip $(($firstip + $num_addrs - 1))) ; do
1089                     if [ $i -gt 254 ] ; then
1090                         die "make_public_addresses: octet > 254 - consider setting PUBLIC_IP_OFFSET"
1091                     fi
1092                     printf "\t${IPBASE}.${e}.${i}/24 eth${e}\n"
1093                 done
1094             done            
1095         fi
1096         echo 
1097     }
1098     hack_all_nodes_with make_public_addresses_for_node
1099 }
1100
1101 ######################################################################
1102
1103 post_config_hooks=
1104
1105 ######################################################################
1106
1107 load_config
1108
1109 ############################
1110 # parse command line options
1111 long_opts=$(getopt_config_options)
1112 getopt_output=$(getopt -n autocluster -o "c:e:E:xh" -l help,dump,with-release: -l "$long_opts" -- "$@")
1113 [ $? != 0 ] && usage
1114
1115 use_default_config=true
1116
1117 # We do 2 passes of the options.  The first time we just handle usage
1118 # and check whether -c is being used.
1119 eval set -- "$getopt_output"
1120 while true ; do
1121     case "$1" in
1122         -c) shift 2 ; use_default_config=false ;;
1123         -e) shift 2 ;;
1124         -E) shift 2 ;;
1125         --) shift ; break ;;
1126         --with-release) shift 2 ;; # Don't set use_default_config=false!!!
1127         --dump|-x) shift ;;
1128         -h|--help) usage ;; # Usage should be shown here for real defaults.
1129         --*) shift 2 ;; # Assume other long opts are valid and take an arg.
1130         *) usage ;; # shouldn't happen, so this is reasonable.
1131     esac
1132 done
1133
1134 config="./config"
1135 $use_default_config && [ -r "$config" ] && . "$config"
1136
1137 eval set -- "$getopt_output"
1138
1139 while true ; do
1140     case "$1" in
1141         # force at least ./local_file to avoid accidental file from $PATH
1142         -c) . "$(dirname $2)/$(basename $2)" ; shift 2 ;;
1143         -e) run_hooks post_config_hooks ; eval "$2" ; exit ;;
1144         -E) eval "$2" ; shift 2 ;;
1145         --with-release)
1146             with_release "$2"
1147             shift 2
1148             ;;
1149         -x) set -x; shift ;;
1150         --dump) run_hooks post_config_hooks ; dump_config ;;
1151         --) shift ; break ;;
1152         -h|--help) usage ;; # Redundant.
1153         --*)
1154             # Putting --opt1|opt2|... into a variable and having case
1155             # match against it as a pattern doesn't work.  The | is
1156             # part of shell syntax, so we need to do this.  Look away
1157             # now to stop your eyes from bleeding! :-)
1158             x=",${long_opts}" # Now each option is surrounded by , and :
1159             if [ "$x" != "${x#*,${1#--}:}" ] ; then
1160                 # Our option, $1, surrounded by , and : was in $x, so is legal.
1161                 setconf_longopt "$1" "$2"; shift 2
1162             else
1163                 usage
1164             fi
1165             ;;
1166         *) usage ;; # shouldn't happen, so this is reasonable.
1167     esac
1168 done
1169
1170 run_hooks post_config_hooks 
1171
1172 # catch errors
1173 set -e
1174 set -E
1175 trap 'es=$?; 
1176       echo ERROR: failed in function \"${FUNCNAME}\" at line ${LINENO} of ${BASH_SOURCE[0]} with code $es; 
1177       exit $es' ERR
1178
1179 # check for needed programs 
1180 check_command expect
1181 if [ "$SYSTEM_DISK_FORMAT" = "qcow2" ] ; then
1182     check_command $QEMU_NBD
1183     check_command nbd-client
1184 fi
1185
1186 [ $# -lt 1 ] && usage
1187
1188 command="$1"
1189 shift
1190
1191 case $command in
1192     create)
1193         type=$1
1194         shift
1195         case $type in
1196             base)
1197                 [ $# != 0 ] && usage
1198                 create_base
1199                 ;;
1200             cluster)
1201                 [ $# != 1 ] && usage
1202                 create_cluster "$1"
1203                 ;;
1204             node)
1205                 [ $# != 2 ] && usage
1206                 create_one_node "$1" "$2"
1207                 ;;
1208             *)
1209                 usage;
1210                 ;;
1211         esac
1212         ;;
1213     mount)
1214         [ $# != 1 ] && usage
1215         diskimage_mount "$1"
1216         ;;
1217     unmount)
1218         [ $# != 0 ] && usage
1219         diskimage_unmount
1220         ;;
1221     bootbase)
1222         boot_base;
1223         ;;
1224     testproxy)
1225         test_proxy;
1226         ;;
1227     *)
1228         usage;
1229         ;;
1230 esac